<?php

/**
    Tool for collaborative workshops.
    Copyright (C) 2016  Albert-Ludwigs-Universität Freiburg

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU Affero General Public License as
    published by the Free Software Foundation, either version 3 of the
    License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Affero General Public License for more details.

    You should have received a copy of the GNU Affero General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

class Template {
    protected $file;
    protected $data;

    public function __construct($file) {
        $this->file = $file;
        $this->data = array();
    }

    public function set($key, $value) {
        $this->data[$key] = $value;
    }

    public function toString() {
        if (!file_exists($this->file)) {
            return "No such file $this->file";
        }
        $result = file_get_contents($this->file);
        foreach ($this->data as $key => $value) {
            $result = str_replace("{{{$key}}}", $value, $result);
        }
        foreach ($this->data as $key => $value) {
            $result = str_replace("{{{$key}}}", $value, $result);
        }
        return $result;
    }
}
