<?php

/**
    Tool for collaborative workshops.
    Copyright (C) 2016  Albert-Ludwigs-Universität Freiburg

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU Affero General Public License as
    published by the Free Software Foundation, either version 3 of the
    License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Affero General Public License for more details.

    You should have received a copy of the GNU Affero General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

require_once('./base.php');

$table_id = -1;

if (isset($_REQUEST['table']) && is_numeric($_REQUEST['table'])) {
    $table_id = intval($_REQUEST['table']);
}

$workshop = new Workshop($table_id);

if (isset($_REQUEST['ajax'])) {
    $result = array('success'=>false);
    $field_id = -1;
    if (isset($_REQUEST['field']) && is_numeric($_REQUEST['field'])) {
        $result['success'] = true;
        $field_id = intval($_REQUEST['field']);
        if (isset($_REQUEST['value'])) {
            $result['value'] = $workshop->writeField($field_id, $_REQUEST['value']);
        } else {
            $result['value'] = $workshop->getField($field_id);
        }
    }
    echo json_encode($result);
} else {
    include('./header.php');
    if ($table_id >= 0) {
        include('./site.php');
    } else {
        $list = "";
        foreach($TABLES as $id => $name) {
            $list .= "<li><a href='./?table=".$id."'>".$name."</a></li>";
        }
        $template = new Template('templates/index.html');
        $template->set("TABLE_LIST", $list);
        echo $template->toString();
    }
    include('./footer.php');
}
