<?php

/**
    Tool for collaborative workshops.
    Copyright (C) 2016  Albert-Ludwigs-Universität Freiburg

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU Affero General Public License as
    published by the Free Software Foundation, either version 3 of the
    License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Affero General Public License for more details.

    You should have received a copy of the GNU Affero General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

require_once("./base.php");

try {
    $db = new PDO(DB_DSN, DB_USER, DB_PASS);
} catch (Exception $e) {
    echo "ADD DATABASE";
    $db = new PDO("mysql:host=".DB_HOST.";charset=utf8", DB_USER, DB_PASS);
    $statement = $db->prepare("CREATE DATABASE IF NOT EXISTS ".DB_NAME." CHARACTER SET utf8 COLLATE utf8_general_ci;");
    $statement->execute(array());
    $statement = $db->prepare("USE DATABASE ".DB_NAME);
    $statement->execute(array());
}

try {
    $result = $db->query("SELECT 1 FROM ".DB_TABLE." LIMIT 1;");
    if ($result === FALSE) {
        throw new Exception('No Table');
    }
} catch (Exception $e) {
    echo "ADD TABLE";
    try {
        $statement = $db->prepare("CREATE TABLE IF NOT EXISTS `".DB_TABLE."` (
  `ID` int(11) NOT NULL AUTO_INCREMENT PRIMARY KEY,
  `Table` int(11) NOT NULL,
  `Field` int(11) NOT NULL,
  `Value` text NOT NULL,
  `Time` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP) 
CHARACTER SET utf8 COLLATE utf8_general_ci;");
        $statement->execute();
    } catch(PDOException $ex) {
        print_r($ex);
    }
}

if (isset($_REQUEST['clean'])) {
    try {
        $statement = $db->prepare("TRUNCATE TABLE `".DB_TABLE."`");
        $statement->execute();
    } catch(PDOException $ex) {
        print_r($ex);
    }
}