/**
    Tool for collaborative workshops.
    Copyright (C) 2016  Albert-Ludwigs-Universität Freiburg

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU Affero General Public License as
    published by the Free Software Foundation, either version 3 of the
    License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Affero General Public License for more details.

    You should have received a copy of the GNU Affero General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

var url = "./index.php";
var timeouts = {};
var fieldHandler = function (event) {
    var target = jQuery(event.target);
    try {
        window.clearTimeout(timeouts[target.data('fieldid')]);
    } catch (e) {
        console.log( "Timeout " + target.data('fieldid') + " unknown!" );
    }
    timeouts[target.data('fieldid')] = window.setTimeout(function () {
        $.ajax({
            type: "POST",
            url: url,
            data: {ajax: true, table: target.data('table'), field: target.data('field'), value: target.val()},
            success: function () {},
            dataType: 'json',
        });
    }, 400);
}

var fieldUpdates = function () {
    jQuery('textarea.get').each(function() {
        var obj = $(this);
        $.getJSON( url, {ajax: true, table: $(this).data('table'), field: $(this).data('field')}, function( data ) {
            if (data.success) {
                obj.val(data.value);
            }
        });
    });
    jQuery('textarea.write').each(function() {
        var obj = $(this);
        $.ajax({
            type: "POST",
            url: url,
            data: {ajax: true, table: $(this).data('table'), field: $(this).data('field'), value: $(this).val()},
            success: function () {},
            dataType: 'json',
        });
    });
}
$(function() {
    console.log( "ready!" );
    jQuery('textarea').each( function (fieldCount) {
        var classes = $(this)[0].className.split(/\s+/);
        $(this).data('fieldid', fieldCount);
        for (var i = 0; i < classes.length; ++i) {
            if (classes[i].indexOf("table-") > -1) {
                $(this).data('table', classes[i].substring("table-".length));
            }
            if (classes[i].indexOf("field-") > -1) {
                $(this).data('field', classes[i].substring("field-".length));
            }
        }
    });
    jQuery('textarea.write').keyup(fieldHandler);
    window.setInterval(fieldUpdates, 5000);
    fieldUpdates();
});